︠88d7a806-2b4b-4b4c-a792-2a0cfc795b82︠
from sage.stats.hmm.distributions import GaussianMixtureDistribution
mean = [2,4,6,8]
prob = [.1,.1,.6,.2]
vari = [.25,.2,.3,.25]
r = len(M)
n = 200
V = GaussianMixtureDistribution((prob[i], mean[i], vari[i]) for i in range(r)).sample(n)
show(V.plot_histogram(bins=100,normalize=False))
V = sorted(list(V))
︡151b2558-5f96-4af0-9563-cc80eb0ecfca︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠997a8366-6173-4146-a91c-9828b9fd0fe4︠
W = []
for i in range(n):
    s = []
    for j in range(n):
        s.append(float(exp(-(V[i]-V[j])**2/2)))
    W.append(s)
W = matrix(W)
︡ca3eb4e6-36c4-4c99-a8ef-9c7b0554afb8︡︡
︠6485ffb9-7a29-48b5-9b20-ed5d8f80eaf6︠
D = []
for i in range(n):
    s = 0
    for j in range(n):
        s += W[i][j]
    D.append(s)
D = diagonal_matrix(D)
︡ef63f22b-05e0-4aa0-a905-b73971c93191︡︡
︠0c129a5b-1670-4b5b-8a01-b46aded0a1bb︠
L = D - W
e = L.right_eigenvectors()
e.sort(key=lambda x: x[0])
e = [(x,v) for x,vs,_ in e for v in vs]
show(points((i,e[i][0]) for i in range(r*3)))
U = matrix(list(list(x[1]) for x in e[:r])).transpose()
show(matrix_plot(U.transpose()))
︡f994c500-94ec-4ec6-b3fe-e866ba9563a8︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡{"html": "<font color='black'><img src='cell://sage1.png'></font>"}︡
︠e23b711d-13e9-4544-9586-b2d5e25f1563︠
DD = diagonal_matrix(list(1/x for x in D.diagonal()))

Lrw = DD * L
e = Lrw.right_eigenvectors()
e.sort(key=lambda x: x[0])
e = [(x,v) for x,vs,_ in e for v in vs]
show(points((i,e[i][0]) for i in range(r*3)))
U = matrix(list(list(x[1]) for x in e[:r])).transpose()
show(matrix_plot(U.transpose()))
︡e958f0b0-cba1-4300-aba3-8e6bc2bfa871︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡{"html": "<font color='black'><img src='cell://sage1.png'></font>"}︡
︠bdc8816a-303a-4ba2-a5e1-82a513c043cd︠
DD = diagonal_matrix(list(1/sqrt(x) for x in D.diagonal()))

Lsym = DD * L * DD
e = Lsym.right_eigenvectors()
e.sort(key=lambda x: x[0])
e = [(x,v) for x,vs,_ in e for v in vs]
show(points((i,e[i][0]) for i in range(r*3)))
U = matrix(list(list(x[1]) for x in e[:r])).transpose()
show(matrix_plot(U.transpose()))

T = []
for i in range(n):
    t = 0
    for j in range(r):
        t += U[i][j] * U[i][j]
    t = sqrt(t)
    s = []
    for j in range(r):
        s.append(U[i][j] / t)
    T.append(s)
T = matrix(T)
show(matrix_plot(T.transpose()))
︡3e562ffb-0a4e-4731-8008-f1e00c9f72e1︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡{"html": "<font color='black'><img src='cell://sage1.png'></font>"}︡{"html": "<font color='black'><img src='cell://sage2.png'></font>"}︡
